<?php

include("../common/config.php");

if (!$config_object->unconfigured) :
	include("../common/database.php");
	include("loginfunc.inc");
	$checked = checkauthentication(default_realm());
	$errorstr = $checked['errorstr'];
	if ($errorstr) :
		header("Location: /admin/");
		exit;
	endif;
endif;

?>
<html>
<head>
<title>
GGZ Community Configuration Wizard
</title>
<style type="text/css">
table {
border-spacing: 0px;
border-width: 0px;
width: 500px;
}
table td {
background-color: #b0b0b0;
padding: 2px;
}
.sel {
background-color: #d0d0d0;
}
.head {
background-color: #ffffff;
border-width: 1px;
border-style: solid;
border-color: #b0b0b0;
}
.headexpl {
background-color: #ffffff;
border-width: 1px;
border-style: solid;
border-color: #b0b0b0;
font-size: smaller;
}
.gap {
background-color: #ffffff;
}
.problem {
background-color: #ffdddd;
}
.noproblem {
background-color: #ddffdd;
}
</style>
</head>
<body>

<?php

$global_problems = array();
$global_noproblems = array();

function problem($problem)
{
	global $global_problems;

	$global_problems[] = $problem;
}

function noproblem($noproblem)
{
	global $global_noproblems;

	$global_noproblems[] = $noproblem;
}

function optbool($s)
{
	if ($s == "on") :
		return "true";
	endif;
	return "false";
}

if ($_POST["savevalues"]) :
	$configfile = "/tmp/htconf.tmp";

	$f = @fopen($configfile, "w");
	if ($f) :
		fwrite($f, "<?php\n");
		fwrite($f, "// Generated by configuration.php\n");
		if ($_POST["form_database"] == "configfile") :
			fwrite($f, "\$ggzconfigfile = \"" . $_POST["form_ggzconfigfile"] . "\";\n");
		else :
			fwrite($f, "\$dbhost = \"" . $_POST["form_dbhost"] . "\";\n");
			fwrite($f, "\$dbport = \"" . $_POST["form_dbport"] . "\";\n");
			fwrite($f, "\$dbname = \"" . $_POST["form_dbname"] . "\";\n");
			fwrite($f, "\$dbuser = \"" . $_POST["form_dbuser"] . "\";\n");
			fwrite($f, "\$dbpass = \"" . $_POST["form_dbpass"] . "\";\n");
			fwrite($f, "\$dbtype = \"" . $_POST["form_dbtype"] . "\";\n");

			fwrite($f, "\$communityregistration = \"" . $_POST["form_communityregistration"] . "\";\n");
		endif;

		if ($_POST["form_ggzserver"] == "query") :
			fwrite($f, "\$ggzurl= \"" . $_POST["form_ggzurl"] . "\";\n");
		else :
			fwrite($f, "\$ggzhost = \"" . $_POST["form_ggzhost"] . "\";\n");
			fwrite($f, "\$ggzname = \"" . $_POST["form_ggzname"] . "\";\n");
			fwrite($f, "\$ggzversion = \"" . $_POST["form_ggzversion"] . "\";\n");
		endif;
		fwrite($f, "\$ggzgamedir = \"" . $_POST["form_ggzgamedir"] . "\";\n");

		fwrite($f, "\$communityname = \"" . $_POST["form_communityname"] . "\";\n");
		fwrite($f, "\$communityslogan = \"" . $_POST["form_communityslogan"] . "\";\n");
		fwrite($f, "\$communityurl = \"" . $_POST["form_communityurl"] . "\";\n");
		fwrite($f, "\$communitymail = \"" . $_POST["form_communitymail"] . "\";\n");
		fwrite($f, "\$communitycopyright_title = \"" . $_POST["form_copyright_title"] . "\";\n");
		fwrite($f, "\$communitycopyright_link = \"" . $_POST["form_copyright_link"] . "\";\n");

		fwrite($f, "\$communitytheme = \"" . $_POST["form_communitytheme"] . "\";\n");
		fwrite($f, "\$communitytls = " . optbool($_POST["form_communitytls"]) . ";\n");

		fwrite($f, "\$features = array(\n");
		fwrite($f, "\t\"blogs\" => " . optbool($_POST["form_features_blogs"]) . ",\n");
		fwrite($f, "\t\"forum\" => " . optbool($_POST["form_features_forum"]) . ",\n");
		fwrite($f, "\t\"articles\" => " . optbool($_POST["form_features_articles"]) . ",\n");
		fwrite($f, "\t\"ggzgames\" => " . optbool($_POST["form_features_ggzgames"]) . ",\n");
		fwrite($f, "\t\"webgames\" => " . optbool($_POST["form_features_webgames"]) . ",\n");
		fwrite($f, "\t\"worldmap\" => " . optbool($_POST["form_features_worldmap"]) . ",\n");
		fwrite($f, "\t\"datarepo\" => " . optbool($_POST["form_features_datarepo"]) . ",\n");
		fwrite($f, "\t\"karma\" => " . optbool($_POST["form_features_karma"]) . "\n");
		fwrite($f, ");\n");

		fwrite($f, "?>\n");

		fclose($f);

		noproblem("Configuration written to $configfile.");

		$final = true;
		$config_object = new Config($configfile);

		include("../common/database.php");
		if ($database) :
			if ($_POST["form_admin_user"]) :
				$config_object->config["registration"] = "open";
				include("../common/auth.php");
				$ret = Auth::register($_POST["form_admin_user"], $_POST["form_admin_pass"], "", "");
				if (!$ret) :
					problem("Admin account could not be registered.");
					$final = false;
				else :
					$database->exec("UPDATE users SET permissions = 415 WHERE handle = '%^'", array($_POST["forum_admin_user"]));
				endif;
			endif;

		else :
			problem("No connection to database possible.");
			$final = false;
		endif;

		if ($final) :
			$finalconfigfile = "../common/htconf";
			if (@rename($configfile, $finalconfigfile)) :
				noproblem("Configuration stored in $finalconfigfile.");

				$configfile = $finalconfigfile;

				noproblem("Configuration wizard finished.");
				noproblem("You can now log in as <a href='/'>administrator</a>.");
			else :
				problem("Storing $configfile as $finalconfigfile failed.");
			endif;
		endif;

	else :
		problem("Writing to $configfile failed.");
	endif;

	$config_object = new Config($configfile);
endif;

if (Config::getvalue("ggzconfigfile")) :
	$checked_database_configfile = " checked=\"checked\"";
	$checked_database_manual = "";
else :
	$checked_database_configfile = "";
	$checked_database_manual = " checked=\"checked\"";
endif;

if (Config::getvalue("ggzurl")) :
	$checked_ggz_server = " checked=\"checked\"";
	$checked_ggz_manual = "";
else :
	$checked_ggz_server = "";
	$checked_ggz_manual = " checked=\"checked\"";
endif;

$selected_open = "";
$selected_confirm = "";
$selected_confirmlater = "";
$selected_closed = "";
if (Config::getvalue("registration") == "closed") :
	$selected_closed = " selected=\"selected\"";
elseif (Config::getvalue("registration") == "confirm") :
	$selected_confirm = " selected=\"selected\"";
elseif (Config::getvalue("registration") == "confirmlater") :
	$selected_confirmlater = " selected=\"selected\"";
else :
	$selected_open = " selected=\"selected\"";
endif;

$selected_default = "";
$selected_widelands = "";
$selected_freeciv = "";
if (Config::themename() == "widelands") :
	$selected_widelands = " selected=\"selected\"";
elseif (Config::themename() == "freeciv") :
	$selected_freeciv = " selected=\"selected\"";
else :
	$selected_default = " selected=\"selected\"";
endif;

$selected_default = "";
$selected_widelands = "";
$selected_freeciv = "";
if (Config::themename() == "widelands") :
	$selected_widelands = " selected=\"selected\"";
elseif (Config::themename() == "freeciv") :
	$selected_freeciv = " selected=\"selected\"";
else :
	$selected_default = " selected=\"selected\"";
endif;

$selected_mysql = "";
$selected_pgsql = "";
if (Config::getvalue("dbtype") == "mysql") :
	$selected_mysql = " selected=\"selected\"";
elseif (Config::getvalue("dbtype") == "postgresql") :
	$selected_pgsql = " selected=\"selected\"";
endif;

$check_tls = "";
$check_blogs = "";
$check_forum = "";
$check_articles = "";
$check_ggzgames = "";
$check_webgames = "";
$check_worldmap = "";
$check_datarepo = "";
$check_karma = "";
if (Config::getvalue("tls")) :
	$check_tls = " checked=\"checked\"";
endif;
if (Config::feature("blogs")) :
	$check_blogs = " checked=\"checked\"";
endif;
if (Config::feature("forum")) :
	$check_forum = " checked=\"checked\"";
endif;
if (Config::feature("articles")) :
	$check_articles = " checked=\"checked\"";
endif;
if (Config::feature("ggzgames")) :
	$check_ggzgames = " checked=\"checked\"";
endif;
if (Config::feature("webgames")) :
	$check_webgames = " checked=\"checked\"";
endif;
if (Config::feature("worldmap")) :
	$check_worldmap = " checked=\"checked\"";
endif;
if (Config::feature("datarepo")) :
	$check_datarepo = " checked=\"checked\"";
endif;
if (Config::feature("karma")) :
	$check_karma = " checked=\"checked\"";
endif;

if ($checked_ggz_server) :
	if (!Config::getvalue("ggzurl")) :
		problem("GGZ URI is not set.");
	else :
		include("../common/ggzd.php");
		$ggzd = new GGZD(Config::getvalue("ggzurl"));
		$ggzd->parse();
		if ($ggzd->error) :
			problem("GGZ URI is set but no connection is possible.");
		endif;
	endif;
endif;
if ($checked_ggz_manual) :
	if (!Config::getvalue("ggzhost")) :
		problem("GGZ hostname is not set");
	endif;
	if (!Config::getvalue("ggzname")) :
		problem("GGZ server name is not set");
	endif;
	if (!Config::getvalue("ggzversion")) :
		problem("GGZ server version is not set");
	endif;
endif;

$configfile = "../common/htconf";
if (is_file($configfile)) :
	if (is_writeable($configfile)) :
		noproblem("Will update configuration file $configfile.");
	else :
		problem("Can probably not write to the configuration file $configfile.");
	endif;
else :
	if (is_writeable(dirname($configfile))) :
		noproblem("Will create new configuration file $configfile.");
	else :
		problem("Can probably not create the configuration file $configfile.");
	endif;
endif;

?>

<h2>GGZ Community Configuration Wizard</h2>

<form action="configuration.php" method="post">

<table>
<tr>

<td colspan="2" class="head">Analysis</td>
</tr><tr>
<td colspan="2" class="headexpl">The following messages show successful configuration steps (green) and remaining problems (red).</td>
</tr><tr>
<td colspan="2" class="problem">

<?php
if (sizeof($global_problems) > 0) :
	foreach ($global_problems as $problem)
	{
		echo "<i>Problem: $problem</i><br/>\n";
	}
endif;
?>

</tr><tr>
<td colspan="2" class="noproblem">

<?php
if (sizeof($global_noproblems) > 0) :
	foreach ($global_noproblems as $noproblem)
	{
		echo "<i>OK: $noproblem</i><br/>\n";
	}
endif;
?>

</tr>
<td colspan="2" class="gap">&nbsp;</td>
</tr><tr>
<td colspan="2" class="head">Admininistrator</td>
</tr><tr>
<td colspan="2" class="headexpl">This will be your first account on this installation. Account details like e-mail address can be configured later. Remember the password! Can be left empty if account already exists.</td>
</tr><tr>
<td>Username:</td><td><input type="text" name="form_admin_user" value=""></td>
</tr><tr>
<td>Password:</td><td><input type="password" name="form_admin_pass" value=""></td>
</tr><tr>
<td colspan="2" class="gap">&nbsp;</td>
</tr><tr>
<td colspan="2" class="head">Database configuration</td>
</tr><tr>
<td colspan="2" class="headexpl">The database must already exist. It is recommended to re-use the ggzd configuration file, if available locally.</td>
</tr><tr>
<td colspan="2" class="sel"><input type="radio" name="form_database" value="configfile"<?php echo $checked_database_configfile; ?>/> Use ggzd configuration file</td>
</tr><tr>
<td>Path to file:</td><td><input type="text" name="form_ggzconfigfile" value="<?php Config::put("ggzconfigfile"); ?>"></td>
</tr><tr>
<td colspan="2" class="sel"><input type="radio" name="form_database" value="manual"<?php echo $checked_database_manual; ?>/> Configure values manually</td>
</tr><tr>
<td>Database type:</td><td><select name="form_dbtype"><option value="postgresql"<?php echo $selected_pgsql; ?>>PostgreSQL</option><option value="mysql"<?php echo $selected_mysql; ?>>MySQL</option></select></td>
</tr><tr>
<td>Database name:</td><td><input type="text" name="form_dbname" value="<?php Config::put("dbname"); ?>"></td>
</tr><tr>
<td>Hostname:</td><td><input type="text" name="form_dbhost" value="<?php Config::put("dbhost"); ?>"></td>
</tr><tr>
<td>Port:</td><td><input type="text" name="form_dbport" value="<?php Config::put("dbport"); ?>"></td>
</tr><tr>
<td>Username:</td><td><input type="text" name="form_dbuser" value="<?php Config::put("dbuser"); ?>"></td>
</tr><tr>
<td>Password:</td><td><input type="text" name="form_dbpass" value="<?php Config::put("dbpass"); ?>"></td>
</tr><tr>
<td>Registration policy:</td><td><select name="form_communityregistration"><option value="open"<?php echo $selected_open; ?>>open for all</option><option value="confirm"<?php echo $selected_confirm; ?>>confirmation before use</option><option value="confirmlater"<?php echo $selected_confirmlater; ?>>confirmation later</option><option value="closed"<?php echo $selected_closed; ?>>closed, invitation only</option></select></td>
</tr><tr>
<td colspan="2" class="gap">&nbsp;</td>
</tr><tr>
<td colspan="2" class="head">GGZ server configuration</td>
</tr><tr>
<td colspan="2" class="headexpl">For live queries, enter the GGZ URI, otherwise enter all data manually. The savegame path will have to be given in any case.</td>
</tr><tr>
<td colspan="2" class="sel"><input type="radio" name="form_ggzserver" value="query"<?php echo $checked_ggz_server; ?>/> Use live query on GGZ server</td>
</tr><tr>
<td>URI of GGZ server:</td><td><input type="text" name="form_ggzurl" value="<?php Config::put("ggzurl"); ?>"></td>
</tr><tr>
<td colspan="2" class="sel"><input type="radio" name="form_ggzserver" value="manual"<?php echo $checked_ggz_manual; ?>/> Configure values manually</td>
</tr><tr>
<td>Hostname:</td><td><input type="text" name="form_ggzhost" value="<?php Config::put("ggzhost"); ?>"></td>
</tr><tr>
<td>Server name:</td><td><input type="text" name="form_ggzname" value="<?php Config::put("ggzname"); ?>"></td>
</tr><tr>
<td>Server version:</td><td><input type="text" name="form_ggzversion" value="<?php Config::put("ggzversion"); ?>"></td>
</tr><tr>
<td colspan="2" class="sel">Miscellaneous</td>
</tr><tr>
<td>Path to savegame directory:</td><td><input type="text" name="form_ggzgamedir" value="<?php Config::put("ggzgamedir"); ?>"></td>
</tr><tr>
<td colspan="2" class="gap">&nbsp;</td>
</tr><tr>
<td colspan="2" class="head">GGZ Community configuration</td>
</tr><tr>
<td colspan="2" class="headexpl">Important meta-data to make this GGZ Community instance unique.</td>
</tr><tr>
<td>Name:</td><td><input type="text" name="form_communityname" value="<?php Config::put("name"); ?>"></td>
</tr><tr>
<td>Slogan:</td><td><input type="text" name="form_communityslogan" value="<?php Config::put("slogan"); ?>"></td>
</tr><tr>
<td>URL:</td><td><input type="text" name="form_communityurl" value="<?php Config::put("url"); ?>"></td>
</tr><tr>
<td>Contact mail address:</td><td><input type="text" name="form_communitymail" value="<?php Config::put("mail"); ?>"></td>
</tr><tr>
<td>Copyright title:</td><td><input type="text" name="form_copyright_title" value="<?php Config::put("copyright_title"); ?>"></td>
</tr><tr>
<td>Copyright URL:</td><td><input type="text" name="form_copyright_link" value="<?php Config::put("copyright_link"); ?>"></td>
</tr><tr>
<td colspan="2" class="gap">&nbsp;</td>
</tr><tr>
<td colspan="2" class="head">GGZ Community appearance</td>
</tr><tr>
<td colspan="2" class="headexpl">The installation can be customized here to your liking.</td>
</tr><tr>
<td colspan="2" class="sel">Miscellaneous</td>
</tr><tr>
<td>Advertise TLS:</td><td><input type="checkbox" name="form_communitytls" <?php echo $check_tls; ?>></td>
</tr><tr>
<td>Theme:</td><td><select name="form_communitytheme"><option value="default"<?php echo $selected_default; ?>>Default</option><option value="freeciv"<?php echo $selected_freeciv; ?>>Freeciv</option><option value="widelands"<?php echo $selected_widelands; ?>>Widelands</option></select></td>
</tr><tr>
<td colspan="2" class="sel">Custom modules</td>
</tr><tr>
<td>Blog aggregation:</td><td><input type="checkbox" name="form_features_blogs" <?php echo $check_blogs; ?>></td>
</tr><tr>
<td>Integrated forum:</td><td><input type="checkbox" name="form_features_forum" <?php echo $check_forum; ?>></td>
</tr><tr>
<td>Show articles:</td><td><input type="checkbox" name="form_features_articles" <?php echo $check_articles; ?>></td>
</tr><tr>
<td>Offer GGZ games:</td><td><input type="checkbox" name="form_features_ggzgames" <?php echo $check_ggzgames; ?>></td>
</tr><tr>
<td>Offer web games:</td><td><input type="checkbox" name="form_features_webgames" <?php echo $check_webgames; ?>></td>
</tr><tr>
<td>World map:</td><td><input type="checkbox" name="form_features_worldmap" <?php echo $check_worldmap; ?>></td>
</tr><tr>
<td>Data repositories:</td><td><input type="checkbox" name="form_features_datarepo" <?php echo $check_datarepo; ?>></td>
</tr><tr>
<td>Karma system:</td><td><input type="checkbox" name="form_features_karma" <?php echo $check_karma; ?>></td>
</tr><tr>
<td colspan="2" class="gap">&nbsp;</td>
</tr><tr>
<td></td><td><input type="submit" name="savevalues" value="Save values"></td>
</tr>
</table>

</form>

</body>
</html>
